/* $Id: array.h,v 1.2 2002/03/04 10:13:38 aa5779 Exp $ */
#ifndef ARRAY_H
#define ARRAY_H

#include "dstring.h"
#include "interp.h"

#ifndef ARRAY_IMP
extern storage_class array_storage_class;
#endif

storage *array_create(interpreter *i, char *name, char *arg);

void array_destroy(interpreter *i, storage *s);

int array_check(interpreter *i, storage *s, dstring *key);
dstring *array_get(interpreter *i, storage *s, dstring *key);

void array_put(interpreter *i, storage *s, dstring *key, dstring *val);
void array_add(interpreter *i, storage *s, dstring *key, dstring *val);

void array_remove(interpreter *i, storage *s, dstring *key);

dstring *array_first(interpreter *i, storage *s, void **iter);
dstring *array_next(interpreter *i, storage *s, void **iter);
void array_enditer(interpreter *i, storage *s, void **iter);

int array_numofitems(interpreter *i, storage *s);

dstring *array_seek(interpreter *i, storage *s, void **iter, dstring *key);

#endif
