/* $Id: uds.h,v 1.2 2002/03/04 10:13:38 aa5779 Exp $ */
#ifndef UDS_H
#define UDS_H

#include "dstring.h"
#include "interp.h"

#ifndef UDS_IMP
extern storage_class uds_storage_class;
#endif

storage *uds_create(interpreter *i, char *name, char *arg);

void uds_destroy(interpreter *i, storage *s);

int uds_check(interpreter *i, storage *s, dstring *key);
dstring *uds_get(interpreter *i, storage *s, dstring *key);

void uds_put(interpreter *i, storage *s, dstring *key, dstring *val);
void uds_add(interpreter *i, storage *s, dstring *key, dstring *val);

void uds_remove(interpreter *i, storage *s, dstring *key);

dstring *uds_first(interpreter *i, storage *s, void **iter);
dstring *uds_next(interpreter *i, storage *s, void **iter);
void uds_enditer(interpreter *i, storage *s, void **iter);

int uds_numofitems(interpreter *i, storage *s);

void uds_init(interpreter *i, storage *s, value *args);

dstring *uds_seek(interpreter *i, storage *s, void **iter, dstring *key);

#endif
